<?php



namespace Supportingcast;

use \WP_User;
use Exception;

class ScUser {

	private $wpUserInterpreter;

	private $data;

	public function __construct(\WP_User $wpUser)
	{
		$this->wpUserInterpreter = new WPUserInterpreter($wpUser,  get_option('sc-member-source'));
	}

	public function __get($property)
	{
		if (isset($this->data->$property)) {
			return $this->data->$property;
		}
		return $this->$property;
	}

	public function fetch()
	{
		$api = new Api();
		$api->get($this->getApiPathBase());

		if (!$api->success()) {
			$api = new Api();
			$api->post('memberships', [
				'external_id' => $this->wpUserInterpreter->getScExternalId(),
				'plan_id'     => $this->wpUserInterpreter->getScPlanId(),
			]);
		}

		if ($api->success()) {
			$this->data = $api->getBody();
			return $api->getBody();
		}

		throw new Exception($api->getErrorMsg());
	}

	public function delete()
	{
		$api = new Api();
		error_log('will try to delete user ' . $this->wpUserInterpreter->getScExternalId() . ' from SC.');

		try {
			$api->delete($this->getApiPathBase());
		} catch (\Throwable $e) {
			error_log('error deleting user from SC');
		}

		if($api->success()) {
			error_log('user successfully deleted from SC.');
		} else {
			error_log('user not successfully deleted from SC.');
		}

	}

	public function getFeeds()
	{
		$api = new Api();
		$api->get("{$this->getApiPathBase()}/feeds");
		if ($api->success()) {
			return (array) $api->getBody();
		}

		throw new Exception($api->getErrorMsg());
	}


	public static function deleted_user_handler($id)
	{
		error_log('starting to delete user ' . $id);
		$user  = new self(get_user_by('id', $id));
		$user->delete();
	}

	private function getApiPathBase(): string
	{
		return 'memberships/' . $this->wpUserInterpreter->getScExternalId();
	}
}