<?php

namespace Supportingcast;

class Sms
{
	public static function register_rest_routes()
	{
		register_rest_route('supportingcast/v1', '/sms', [
			'methods'             => 'POST',
			'callback'            => [static::class, 'send'],
			'permission_callback' => function () {
				return is_user_logged_in();
			},
		]);
	}

	public static function send($data)
	{
		$response = ['status' => 'error', 'data' => null, 'message' => null];

		if ( ! is_user_logged_in()) {
			$response['message'] = 'Unauthorized';

			return $response;
		};

		$api = new Api();

		$api->post('sms/feed', $data->get_json_params());

		if ($api->success()) {
			$response['status'] = 'success';

			return $response;
		}

		$response['message'] = $api->getErrorMsg();

		return $response;
	}
}